%define mibs_version 0.4

Summary:	Netdisco is a Web-based network management tool
Name:		netdisco
Version:	0.95
Release:	%mkrel 2
License:	BSD
Group:		System/Servers
URL:		http://netdisco.org/
Source0:	http://prdownloads.sourceforge.net/netdisco/%{name}-%{version}.tar.bz2
Source1:	http://prdownloads.sourceforge.net/netdisco/netdisco-mibs-%{mibs_version}.tar.bz2
Source2:	netdisco.init
#rrdtool:/usr/share/rrdtool/fonts/DejaVuSansMono-Roman.ttf
Source3:	DejaVuSansMono-Roman.ttf.bz2
Source4:	netdisco_bootstrap.sh
Source5:	http://standards.ieee.org/regauth/oui/oui.txt
Source6:	netdisco-16x16.png
Source7:	netdisco-32x32.png
Source8:	netdisco-48x48.png
Patch0:		netdisco-0.95-mdv_conf.diff
Patch1:		netdisco-0.95-20060408-autohandler_revert.diff
Requires(post): desktop-file-utils
Requires(postun): desktop-file-utils
Requires(post): rpm-helper
Requires(preun): rpm-helper
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Requires(pre):	apache-mod_php apache-mod_ssl
Requires:	apache-mod_php apache-mod_ssl
Requires:	apache-mod_perl >= 1:2.0.2
Requires:	apache-mod_apreq >= 2.07
Requires:	net-snmp-mibs net-snmp net-snmp-utils
Requires:	perl-Apache-DBI
Requires:	perl-Apache-ProxyRewrite >= 0.17-3mdk
Requires:	perl-GraphViz
Requires:	perl-HTML-Mason >= 1.24
Requires:	perl-SNMP-Info
Requires:	perl-MasonX-Request-ExtendedCompRoot
Requires:	perl-MasonX-Request-ExtendedCompRoot-WithApacheSession
Requires:	perl-MasonX-Request-WithApacheSession
Requires:	perl-Graph >= 0.5
Requires:	graphviz
Requires:	postgresql postgresql-server
BuildRequires:	apache-base >= 2.0.54
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
Netdisco is a Web-based network management tool. Users can locate the switch
port of an end-user system by IP or MAC address. Data is stored using a SQL
database. Cisco Discovery Protocol (CDP) optionally provides automatic
discovery of the network topology. The network is inventoried by both device
model and operating system (like IOS). It uses router ARP tables and L2 switch
MAC forwarding tables to locate nodes on physical ports and track them by their
IP addresses. For each node, a time stamped history of the ports it has visited
and the IP addresses it has used is maintained. It gets all its data, including
CDP topology information, with SNMP polls and DNS queries. Security features
include a wire-side Wireless Access Point (AP) locator.

%prep

%setup -q -n %{name}-%{version} -a1
mv netdisco-mibs-%{mibs_version} mibs

find . -type d -perm 0700 -exec chmod 755 {} \;
find . -type f -perm 0555 -exec chmod 755 {} \;
find . -type f -perm 0444 -exec chmod 644 {} \;

for i in `find . -type d -name CVS`  `find . -type d -name .svn` `find . -type f -name .cvs\*` `find . -type f -name .#\*`; do
    if [ -e "$i" ]; then rm -rf $i; fi >&/dev/null
done

%patch0 -p1
%patch1 -p0

cp %{SOURCE2} netdisco.init
bzcat %{SOURCE3} > DejaVuSansMono-Roman.ttf

cp %{SOURCE4} netdisco_bootstrap.sh
cp %{SOURCE5} oui.txt
cp %{SOURCE6} %{SOURCE7} %{SOURCE8} .

# small fixes ahead...
perl -pi -e "s|^POD2TEXT.*|POD2TEXT = %{_bindir}/pod2text|g" Makefile
perl -pi -e "s|^POD2MAN.*|POD2MAN = %{_bindir}/pod2man|g" Makefile
perl -pi -e "s|^POD2HTML.*|POD2HTML = %{_bindir}/pod2html|g" Makefile
perl -pi -e "s|^SNMPLIBS.*|SNMPLIBS = |g" Makefile

# prefix fix
find -type f | xargs perl -pi -e "s|/usr/local/netdisco|/var/www/netdisco|g"

# config file path fix
perl -pi -e "s|\"\\\$Dir/netdisco\.conf\"\;|\'%{_sysconfdir}/netdisco\.conf\'\;|" sql/pg

%build

make doc

# make some man pages too :)
pod2man netdisco > netdisco.1
pod2man netdisco.pm > netdisco.pm.1

%install
rm -rf %{buildroot}

# don't fiddle with the initscript!
export DONT_GPRINTIFY=1

install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_mandir}/man1
install -d %{buildroot}/var/www/netdisco/switch
install -d %{buildroot}/var/www/netdisco/data/logs
install -d %{buildroot}/var/run/netdisco

install -m0644 netdisco.conf %{buildroot}%{_sysconfdir}/
install -m0644 netdisco_apache.conf %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d/
install -m0644 netdisco_apache_dir.conf %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d/
install -m0755 netdisco %{buildroot}%{_sbindir}/

install -m0644 netdisco.1 %{buildroot}%{_mandir}/man1/
install -m0644 netdisco.pm.1 %{buildroot}%{_mandir}/man1/

cp -aRf * %{buildroot}/var/www/%{name}/

install -m0755 netdisco.init %{buildroot}%{_initrddir}/netdisco
install -m0755 netdisco_bootstrap.sh %{buildroot}%{_sbindir}/netdisco_bootstrap
install -m0644 DejaVuSansMono-Roman.ttf %{buildroot}/var/www/netdisco/

# cleanup
pushd %{buildroot}/var/www/netdisco
    rm -rf doc
    rm -f ChangeLog INSTALL Makefile README* UPGRADE
    rm -f netdisco.conf netdisco_apache.conf netdisco_apache_dir.conf netdisco
    rm -f bin/debian_install.sh bin/fix_cvsroot bin/netdisco_daemon
    rm -f netdisco.init DejaVuSansMono-Roman.ttf netdisco_bootstrap.sh
    rm -f netdisco.1 netdisco.pm.1 netdisco-*.png
popd

cat > README.urpmi << EOF
N E T D I S C O
---------------

Please read the documentaion files first:

 o %{_docdir}/%{name}-%{version}/INSTALL
 o %{_docdir}/%{name}-%{version}/README
 o %{_docdir}/%{name}-%{version}/UPGRADE

For fresh installations you can try to use the netdisco_bootstrap
script (unsupported):

%{_sbindir}/netdisco_bootstrap

Good luck!
EOF

touch %{buildroot}/var/www/netdisco/html/netmap.gif
touch %{buildroot}/var/www/netdisco/html/netmap.map

# Mandriva Icons
install -d %{buildroot}%{_iconsdir}
install -d %{buildroot}%{_miconsdir}
install -d %{buildroot}%{_liconsdir}
install -m0644 netdisco-16x16.png %{buildroot}%{_miconsdir}/%{name}.png
install -m0644 netdisco-32x32.png %{buildroot}%{_iconsdir}/%{name}.png
install -m0644 netdisco-48x48.png %{buildroot}%{_liconsdir}/%{name}.png

# install menu entry.
install -d %{buildroot}%{_menudir}
cat > %{buildroot}%{_menudir}/%{name} << EOF
?package(%{name}): \
needs=X11 \
section="System/Monitoring" \
title="Netdisco" \
longtitle="%{summary}" \
command="%{_bindir}/www-browser http://localhost/%{name}/" \
icon="%{name}.png" \
xdg=true
EOF

# XDG menu
install -d %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/mandriva-%{name}.desktop << EOF
[Desktop Entry]
Name=Netdisco
Comment=%{summary}
Exec="%{_bindir}/www-browser http://localhost/%{name}/"
Icon=%{name}
Terminal=false
Type=Application
Categories=X-MandrivaLinux-System-Monitoring;System;Monitor;
EOF

%pre
%_pre_useradd netdisco /var/www/netdisco /bin/sh
# apache needs to read /etc/netdisco.conf, but it contains a plain 
# text password to the postgresql netdisco database, so the file
# requires stricter file permissions...
/usr/bin/gpasswd -a apache netdisco

%post
%_post_webapp
%update_menus
%update_desktop_database
%create_ghostfile /var/www/netdisco/html/netmap.gif netdisco netdisco 644
%create_ghostfile /var/www/netdisco/html/netmap.map netdisco netdisco 644
%_post_service netdisco
if [ -f /var/lock/subsys/netdisco ]; then
    %{_initrddir}/netdisco restart 1>&2;
fi

%preun
%_preun_service netdisco

%postun
%_postun_webapp
%clean_menus
%clean_desktop_database
if [ "$1" = "0" ]; then
    # remove the crontab for netdisco
    crontab -r -u netdisco
fi
%_postun_userdel netdisco

%clean
rm -rf %{buildroot}

%files 
%defattr(-,root,root)
%doc ChangeLog INSTALL README* UPGRADE
%attr(0755,root,root) %{_initrddir}/netdisco
%attr(0640,netdisco,root) %config(noreplace) %{_sysconfdir}/netdisco.conf
%attr(0640,root,root) %config(noreplace) %{_sysconfdir}/httpd/conf/webapps.d/netdisco_apache.conf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/conf/webapps.d/netdisco_apache_dir.conf
%attr(0755,root,root) %{_sbindir}/netdisco
%attr(0755,root,root) %{_sbindir}/netdisco_bootstrap
%dir /var/www/netdisco
/var/www/netdisco/*
%attr(0755,netdisco,netdisco) %dir /var/www/netdisco/data
%attr(0755,netdisco,netdisco) %dir /var/www/netdisco/data/logs
%attr(0755,netdisco,netdisco) %dir /var/run/netdisco
%{_menudir}/%{name}
%{_iconsdir}/%{name}.png
%{_miconsdir}/%{name}.png
%{_liconsdir}/%{name}.png
%{_datadir}/applications/*.desktop
%ghost %attr(0644,netdisco,netdisco) %config(noreplace) /var/www/netdisco/html/netmap.gif
%ghost %attr(0644,netdisco,netdisco) %config(noreplace) /var/www/netdisco/html/netmap.map
%{_mandir}/man1/*


%changelog
* Fri Dec 15 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-2mdv2007.0
+ Revision: 97487
- added more fixes
- added fixes by Walter Gould

* Wed Nov 29 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-1mdv2007.1
+ Revision: 88607
- 0.95 final
- netdisco-mibs-0.4
- rediffed P0
- new S5 (oui.txt)

* Wed Nov 15 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-0.20061115.1mdv2007.1
+ Revision: 84565
- new cvs snapshot (20061115), or pretty close to 0.95 final
- new mibs snapshot (20061115)

* Tue Nov 14 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-0.20060415.3mdv2007.1
+ Revision: 84116
- Import netdisco



* Tue Nov 14 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-0.20060415.3mdv2007.1
- fix the xdg menu stuff
- use the www-browser script instead of self contained one
- bunzip sources

* Tue May 16 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-0.20060415.2mdk
- make it actually work this time... (new P0)

* Mon May 15 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-0.20060415.1mdk
- new snap (20060415)
- rediffed P0
- add mod_rewrite rules to enforce ssl connections
- fix deps

* Wed Apr 12 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-0.20060408.2mdk
- added P1 to revert the defunc apache_auth stuff

* Sat Apr 08 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-0.20060408.1mdk
- new snap (20060408)
- rediffed P0
- drop upstream patches; P1,P2

* Thu Feb 16 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-0.20060117.10mdk
- added the missing subnets table when making the postgresql database

* Thu Feb 16 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-0.20060117.9mdk
- more permission fixes, apache needs to be able to read /etc/netdisco.conf
- added a menu entry

* Thu Feb 16 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-0.20060117.8mdk
- more permission fixes

* Wed Feb 15 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-0.20060117.7mdk
- fix permissions
- fixed the bootstrap script to work a bit safer

* Wed Feb 15 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-0.20060117.6mdk
- fix docs (thanks for the sed tip pterjan)

* Wed Feb 15 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-0.20060117.5mdk
- the oui.txt file was missing
- fix deps
- fixed the bootstrap script to work better

* Wed Feb 15 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-0.20060117.4mdk
- added changes by Buchan Milne in P0 (also S3)
- new mibs snap (20060210)
- fixed the initscript (S2)
- added a modified bootstrap script by debian (S4)

* Thu Feb 02 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-0.20060117.3mdk
- fix deps

* Mon Jan 30 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-0.20060117.2mdk
- fix url (thanks "J.P. Pasnak")

* Mon Jan 30 2006 Oden Eriksson <oeriksson@mandriva.com> 0.95-0.20060117.1mdk
- use a recent snap (20060117)
- rediffed P0
- fix deps
- added P1 after skimming the mailinglists at sourceforge

* Thu Jan 26 2006 Oden Eriksson <oeriksson@mandriva.com> 0.94-0.1mdk
- initial Mandriva package (first draft)
